import 'package:unittest/unittest.dart';
import 'package:unittest/vm_config.dart';
import 'package:iskernel_html_tablesorter/src/utils.dart';


void tryParseInt_WithIntValue_ReturnIntValue()
{
  expect
  (
      tryParseInt("3"),
      equals(3)
  );
}

void tryParseInt_WithLettersStringValue_ReturnNull()
{
  expect
  (
    tryParseInt("this is a string"),
    isNull
  );
}

void tryParseInt_WithDoubleValue_ReturnNull()
{
  expect
  (
    tryParseInt("3.0"),
    isNull
  );
}

void tryParseDouble_WithIntValue_ReturnDoubleValue()
{
  expect
  (
      tryParseDouble("3"),
      equals(3.0)
  );
}

void tryParseDouble_WithRandomStringValue_ReturnNulll()
{
  expect
  (
    tryParseDouble("exampleString"),
    isNull
  );
}

void tryParseDouble_WithDoubleValue_ReturnDouble()
{
  expect
  (
    tryParseDouble("3.0"),
    equals(3.0)
  );
}

void group_tryParseInt_Tests()
{
  group
  (
    "tryParseInt group - ", 
    () 
    {
      test
      (
          "tryParseInt with int value as string returns an int value", 
          tryParseInt_WithIntValue_ReturnIntValue
      );
      test
      (
          "tryParseInt with random string value as strings returns null", 
          tryParseInt_WithLettersStringValue_ReturnNull
      );
      test
      (
          "tryParseInt with double value as strings returns null", 
          tryParseInt_WithDoubleValue_ReturnNull
      );
    }
  );
}

void group_tryParseDouble_Tests()
{
  group
  (
    "tryParseDouble group - ", 
    () 
    {
      test
      (
          "tryParseDouble with int value as string returns an double value", 
          tryParseDouble_WithIntValue_ReturnDoubleValue
      );
      test
      (
          "tryParseDouble with random string value as strings returns null", 
          tryParseDouble_WithRandomStringValue_ReturnNulll
      );
      test
      (
          "tryParseDouble with double value as string returns double value", 
          tryParseDouble_WithDoubleValue_ReturnDouble
      );
    }
  );
}

void main()
{
  group_tryParseInt_Tests();
  group_tryParseDouble_Tests();
}